> ## Documentation Index
> Fetch the complete documentation index at: https://documentation.byteful.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Search Service Adjustments

> Search Service Adjustments on the customer account using various filters.




## OpenAPI

````yaml get /public/user/service_adjustment/search
openapi: 3.0.1
info:
  title: Byteful Public User API
  description: Public API used for third-party usage.
  termsOfService: https://byteful.com
  contact:
    url: https://byteful.com
    email: developer@byteful.com
  version: '1.0'
  x-logo:
    altText: Byteful
    backgroundColor: '#6354eb'
    url: >-
      https://pbs.twimg.com/profile_banners/1038803520605118464/1729783007/1500x500
servers:
  - url: https://api.byteful.com/1.0/
security: []
paths:
  /public/user/service_adjustment/search:
    get:
      tags:
        - Service Adjustment
      summary: Search Service Adjustments
      description: >
        Search Service Adjustments on the customer account using various
        filters.
      parameters:
        - name: invoice_id
          in: query
          description: ID of the invoice
          schema:
            type: string
        - name: service_id
          in: query
          description: Service ID associated with the service adjustment
          schema:
            type: string
        - name: service_adjustment_id
          in: query
          description: ID of the service adjustment
          schema:
            type: integer
            format: string
        - name: service_adjustment_type
          in: query
          description: Type of the service adjustment
          schema:
            type: string
            enum:
              - ingestion
              - fulfillment
              - update
              - proxy_replacement
              - extension
              - cancel
              - remove_proxy
              - additional_fulfillment
              - top_up
              - top_up_and_extension
              - cancel
        - name: service_adjustment_status
          in: query
          description: Current status of the service adjustment
          schema:
            type: string
            enum:
              - pending
              - complete
              - failed
        - name: service_adjustment_is_administrator
          in: query
          description: Whether the adjustment was made by an administrator
          schema:
            type: boolean
        - name: service_adjustment_is_automatic
          in: query
          description: Whether the adjustment was made automatically
          schema:
            type: boolean
        - name: service_adjustment_is_customer
          in: query
          description: Whether the adjustment was made by a customer
          schema:
            type: boolean
        - name: service_adjustment_creation_datetime
          in: query
          description: Datetime the service adjustment was created
          schema:
            type: string
            format: date-time
        - name: service_adjustment_last_update_datetime
          in: query
          description: Datetime the service adjustment was last updated
          schema:
            type: string
            format: date-time
        - name: per_page
          in: query
          description: Number of items per page for pagination
          schema:
            type: integer
        - name: page
          in: query
          description: Page number for pagination
          schema:
            type: integer
        - name: sort_by
          in: query
          description: Key for sorting or random.
          schema:
            type: string
      responses:
        '200':
          description: Successful Service Adjustment search
          content:
            application/json:
              schema:
                allOf:
                  - $ref: >-
                      #/components/schemas/ServiceAdjustmentSuccessfulSearchResponse
                  - type: object
                    properties:
                      data:
                        type: array
                        items:
                          type: object
                          properties:
                            proxy_replacements:
                              type: array
                              items:
                                $ref: '#/components/schemas/ProxyReplacement'
      security:
        - APIPrivateKey: []
          APIPublicKey: []
components:
  schemas:
    ServiceAdjustmentSuccessfulSearchResponse:
      type: object
      properties:
        data:
          type: array
          description: >-
            Array of Service Adjustment items matching the search criteria up to
            the limit of per_page paramater.
          items:
            type: object
            properties:
              invoice_id:
                type: string
                example: in_1NpRIvB2BUlqim5lN4v3URka
              service_adjustment_creation_datetime:
                type: string
                format: date-time
              service_adjustment_eval:
                type: object
                properties: {}
                example:
                  service_expiry_datetime:
                    - '2023-09-14 18:30:00'
                    - '2024-09-14 18:30:00'
              service_adjustment_id:
                type: integer
                example: 213
              service_adjustment_is_administrator:
                type: boolean
                example: false
              service_adjustment_is_automatic:
                type: boolean
                example: true
              service_adjustment_is_customer:
                type: boolean
                example: true
              service_adjustment_last_update_datetime:
                type: string
                format: date-time
              service_adjustment_post:
                type: object
                properties: {}
                example:
                  service_expiry_datetime: '2024-09-14 18:30:00'
              service_adjustment_pre:
                type: object
                properties: {}
                example:
                  service_expiry_datetime: '2023-09-14 18:30:00'
              service_adjustment_status:
                type: string
                example: complete
                enum:
                  - complete
                  - pending
                  - failed
              service_adjustment_type:
                type: string
                example: extension
                enum:
                  - ingestion
                  - fulfillment
                  - remove_proxy
                  - additional_fulfillment
                  - update
                  - proxy_replacement
                  - extension
                  - top_up
                  - top_up_and_extension
                  - cancel
              service_id:
                type: string
                example: API-1234-5678
        item_count:
          type: integer
          description: Total number of Service Adjustment items returned in the data field.
        message:
          type: string
          description: Status message for the search.
        page:
          type: integer
          description: Current page number of the search results returned.
        per_page:
          type: integer
          description: Number of Service Adjustment items returned per page.
        total_count:
          type: integer
          description: Total of Service Adjustment items that match the search filter.
      description: Service Adjustment search was successful.
      example:
        data:
          - invoice_id: in_1NpRIvB2BUlqim5lN4v3URka
            service_adjustment_creation_datetime: '2023-09-14 18:30:00'
            service_adjustment_eval:
              service_expiry_datetime:
                - '2023-09-14 18:30:00'
                - '2024-09-14 18:30:00'
            service_adjustment_id: 213
            service_adjustment_is_administrator: false
            service_adjustment_is_automatic: true
            service_adjustment_is_customer: true
            service_adjustment_last_update_datetime: '2023-09-15 18:30:00'
            service_adjustment_post:
              service_expiry_datetime: '2024-09-14 18:30:00'
            service_adjustment_pre:
              service_expiry_datetime: '2023-09-14 18:30:00'
            service_adjustment_status: complete
            service_adjustment_type: extension
            service_id: API-1234-5678
        item_count: 1
        message: Service Adjustment search successful.
        page: 1
        per_page: 10
        total_count: 1
    ProxyReplacement:
      type: object
      properties:
        proxy_replacement_creation_datetime:
          type: string
          format: date-time
        proxy_replacement_http_port:
          type: integer
          example: 8080
        proxy_replacement_id:
          type: integer
          example: 7018
        proxy_replacement_ip_address_ipv4:
          type: string
          example: 107.225.73.142
        proxy_replacement_ip_address_ipv6:
          type: string
          example: 2600:1000:b12a:6351:8523:997e:93c4:f124
        proxy_replacement_new_http_port:
          type: integer
          example: 8080
        proxy_replacement_new_ip_address_ipv4:
          type: string
          example: 107.225.74.89
        proxy_replacement_new_ip_address_ipv6:
          type: string
          example: 2600:1000:b12a:728f:452d:a76c:e91b:d235
        proxy_replacement_new_socks5_port:
          type: integer
          example: 1080
        proxy_replacement_reason:
          type: string
          example: customer_request
          enum:
            - customer_request
            - ip_reputation
            - end_of_deployment
            - outage
            - other
        proxy_replacement_socks5_port:
          type: integer
          example: 1080
  securitySchemes:
    APIPrivateKey:
      type: apiKey
      description: ' Private API key for user-level authentication.'
      name: X-API-Private-Key
      in: header
    APIPublicKey:
      type: apiKey
      description: ' Public API key for user-level authentication.'
      name: X-API-Public-Key
      in: header

````